unit laskuriform;
(*
  My first Delphi Application
  Miika Nurminen, 2.4.2004.
*)
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, aboutform;

type
{------------------------------------------------------------------------------}
	{ Aluksi luokka, joka on itse asiassa sama kuin TControl, mutta jolla saadaan  }
	{ vri julkiseksi ominaisuudeksi.                                              }
	  TColorControl = class(TControl)
	  published
	    property Color;
	  end;

  TForm1 = class(TForm)
    ButtonHA: TButton;
    ButtonKA: TButton;
    LabelHA: TLabel;
    LabelKA: TLabel;
    ButtonNollaa: TButton;
    ImageHA: TImage;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    Colors1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    ColorDialogTausta: TColorDialog;
    PopupMenu1: TPopupMenu;
    VV1: TMenuItem;
    procedure ButtonHAClick(Sender: TObject);
    procedure ButtonNollaaClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Colors1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure LabelHAClick(Sender: TObject);
    procedure LabelHADragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure LabelHADragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure VV1Click(Sender: TObject);
  private
    procedure adjustColor(sender:TControl);

  // CTRL+SHIFT+C <-- tydent luokan
  // CTRL+SHIFT+nuoli yls/alas, liikkuu toteutukseen
    procedure lisaa(target: TLabel; n:integer = 1);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.LabelHAClick(Sender: TObject);
begin
(* if (dynamic_cast<TLabel*>(Sender)!=NULL) *)

  if (Sender is TLabel) then lisaa(Sender as TLabel);
end;

(* huom. oletetaan, ett TLabel-komponentissa on
   numeromuotoinen otsikko *)
procedure TForm1.lisaa(target: TLabel; n:integer);
begin
  target.Caption:=IntToStr(StrToInt(target.Caption)+n);
end;


procedure TForm1.ButtonHAClick(Sender: TObject);
begin    (* == *)
  if (Sender=ButtonHA) then lisaa(LabelHA)
  else if (Sender=ButtonKA) then lisaa(LabelKA);

(* alkuperinen koodi:
    LabelHA.Caption:=IntToStr(StrToInt(LabelHA.Caption)+1);
*)
end;

procedure TForm1.ButtonNollaaClick(Sender: TObject);
begin
  LabelHA.Caption:='0';
  LabelKA.Caption:='0';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   ImageHA.Left := ImageHA.Left+1;
end;

procedure TForm1.adjustColor(Sender: TControl);
var c:TColorControl;
begin
     // vastaa c++:n reinterpret_cast<TColorControl*>(Sender)
     // tai          (TColorControl)(Sender)
  c := TColorControl(Sender);
  // ei toimi: Sender as TColorControl;
  ColorDialogTausta.Color := c.Color;
  if ( not ColorDialogTausta.Execute ) then exit;
	c.Color := ColorDialogTausta.Color;
end;

procedure TForm1.Exit1Click(Sender: TObject);
var w:TWinControl;
begin
(* this->close() *)
//  self.Close;
  Close;
end;

procedure TForm1.Colors1Click(Sender: TObject);
begin
  ColorDialogTausta.Color := self.Color;
(* if (! ColorDialogTausta->Execute() ) return; *)
  if ( not ColorDialogTausta.Execute ) then exit;
	Color := ColorDialogTausta.Color;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
   FormAbout.Show;
end;


procedure TForm1.LabelHADragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := true;
end;

procedure TForm1.LabelHADragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if (Sender is TLabel) then lisaa(Sender as TLabel,10);
end;




procedure TForm1.VV1Click(Sender: TObject);
begin
  if (PopupMenu1.PopupComponent is TControl) then
    adjustcolor(PopupMenu1.PopupComponent as TControl);
end;

end.
